<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>Magical Mystery Tour Checkout</title>

    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
          integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <meta name="theme-color" content="#563d7c">
    <script src="https://static.checkout.sandbox.littlepay.com/littlepay-checkout.min.js"></script>

<body class="bg-light">
<div class="container">
    <div class="py-5 text-center">
        <img class="d-block mx-auto mb-4" src="/img/bus.png" alt="" width="200">
        <h2>
            Magical Mystery Tours<br/>
            <small>Checkout</small>
        </h2>
        <p class="lead">Here you can review your cart. When you are ready, please enter your address and payment
            details.</p>
    </div>

    <div class="row">
        <div class="col-md-4 order-md-2 mb-4">
            <h4 class="d-flex justify-content-between align-items-center mb-3">
                <span class="text-muted">Your cart</span>
                <span class="badge badge-secondary badge-pill">2</span>
            </h4>
            <ul class="list-group mb-3">
                <li class="list-group-item d-flex justify-content-between lh-condensed">
                    <div>
                        <h6 class="my-0">Monthly bus ticket</h6>
                        <small class="text-muted">Valid monthly bus ticket</small>
                    </div>
                    <span class="text-muted">£32.00</span>
                </li>
                <li class="list-group-item d-flex justify-content-between lh-condensed">
                    <div>
                        <h6 class="my-0">Day tripper</h6>
                        <small class="text-muted">Valid daily bus ticket</small>
                    </div>
                    <span class="text-muted">£8.00</span>
                </li>
                <li class="list-group-item d-flex justify-content-between">
                    <span>Total (GBP)</span>
                    <strong>£40.00</strong>
                </li>
            </ul>
        </div>
        <div id="success-page" class="col-md-8 order-md-1 d-none">
            <h4 class="mb-3">Checkout Success</h4>
            <div id="success-msg" class="alert alert-success" role="alert">
                Thank you, your payment was successfully processed.
            </div>
            <div id="success-payment-intent-id-msg" class="" role=""></div>
        </div>
        <div id="checkout-page" class="col-md-8 order-md-1 d-none">
            <h4 class="mb-3">Payment</h4>
            <div id="error-msg" class="alert alert-danger d-none" role="alert">

            </div>
            <div id="littlepay-checkout-container"></div>
            <hr class="mb-4">
            <button id="cancel-btn" class="btn btn-secondary btn-lg btn-block nav-btn">Cancel</button>
        </div>
        <div id="address-page" class="col-md-8 order-md-1">
            <h4 class="mb-3">Billing address</h4>
            <form class="needs-validation" novalidate="">
                <div class="row">
                    <div class="col-md-6 mb-3">
                        <label for="firstName">First name</label>
                        <input type="text" class="form-control" id="firstName" placeholder="Brian" value="" required="">
                    </div>
                    <div class="col-md-6 mb-3">
                        <label for="lastName">Last name</label>
                        <input type="text" class="form-control" id="lastName" placeholder="Jackson" value="" required="">
                    </div>
                </div>

                <div class="mb-3">
                    <label for="address">Address</label>
                    <input type="text" class="form-control" id="address" placeholder="52a Birmingham Road" required="">
                </div>

                <div class="mb-3">
                    <label for="address2">Address 2 <span class="text-muted">(Optional)</span></label>
                    <input type="text" class="form-control" id="address2" >
                </div>

                <div class="row">
                    <div class="col-md-3 mb-3">
                        <label for="postcode">Postcode</label>
                        <input type="text" class="form-control" id="postcode" placeholder="E39AB" required="">
                    </div>
                    <div class="col-md-5 mb-3">
                        <label for="country">Country</label>
                        <select class="custom-select d-block w-100" id="country" disabled="" >
                            <option value="GB">United Kingdom</option>
                        </select>
                    </div>
                </div>

                <hr class="mb-4">

                <button class="btn btn-primary btn-lg btn-block nav-btn">Continue to checkout</button>
            </form>
        </div>
    </div>

    <footer class="my-5 pt-5 text-muted text-center text-small">
        <p class="mb-1">© 2020 Magical Mystery Tours</p>
        <ul class="list-inline">
            <li class="list-inline-item"><a href="#">Privacy</a></li>
            <li class="list-inline-item"><a href="#">Terms</a></li>
            <li class="list-inline-item"><a href="#">Support</a></li>
        </ul>
    </footer>
</div>
</body>
<script>
  (function() {
    const navButtons = document.getElementsByClassName('nav-btn');
    const checkoutPageElem = document.getElementById('checkout-page');
    const addressPageElem = document.getElementById('address-page');
    const successPageElem = document.getElementById('success-page');
    const errorMessageElem = document.getElementById('error-msg');
    const successMessageElem = document.getElementById('success-payment-intent-id-msg');

    for (let i = 0; i < navButtons.length; i++) {
      navButtons[i].addEventListener('click', function(e) {
        e.preventDefault();
        addressPageElem.classList.toggle('d-none');
        checkoutPageElem.classList.toggle('d-none');
        if (e.currentTarget.id === 'cancel-btn') {
          init()
        }
      });
    }

    function onSuccess(paymentIntentId) {
      addressPageElem.classList.add('d-none');
      checkoutPageElem.classList.add('d-none');
      errorMessageElem.classList.add('d-none');
      successMessageElem.innerHTML = 'The Payment Intent ID that uniquely identifies your transaction is: <br />' + paymentIntentId
      successPageElem.classList.add('d-block')
    }

    function onError(littlepayError) {
      var errMsg;
      if (typeof littlepayError.toString === 'function') {
        errMsg = littlepayError.toString()
      } else {
        errMsg = JSON.stringify(littlepayError)
      }
      errorMessageElem.textContent = 'Something went wrong. Received error:\n ' + errMsg
      errorMessageElem.classList.add('d-block');
    }

    /**
     * Launching littlepay-javascript SDK
     */
    function init() {
      if (window.LittlePay) {
        // For the purpose of the demo app, address here is hardcoded
        // in the real world merchant would pass customer address
        const address = {
          addressLineOne: '61 Wellfield Road',
          townCity: 'Cardiff',
          postcode: 'CF24 3DG',
          country: 'GB',
        };
        const customTheme = {
         color: '#444',
         backgroundColor: '#f8f9fa',
         loadingScreen: {
           color: '#1dbd72',
           backgroundColor: '#f8f9fa',
         },
         button: {
           color: '#ffffff',
           backgroundColor: '#1dbd72',
         },
         errorMessage: {
           color: '#ffffff',
           backgroundColor: '#FF0000',
         },
         navigationBar: {
           color: '#ffffff',
           backgroundColor: '#6c757d',
         },
       };

        // server creates Payment Intent and returns id and clientToken
        fetch('/checkout-data')
          .then(res => res.json())
          .then(intentCreationResponse => {
            const littlepay = window.LittlePay({
              targetElementId: 'littlepay-checkout-container',
              options: {
                address: address,
                theme: customTheme,
              },
              clientToken: intentCreationResponse.clientToken,
            });
            littlepay.makePayment(onError, onSuccess);
          });
      } else {
        console.error('window.LittlePay is undefined');
      }
    }
    init();
  })();
</script>
</html>
